]> git.madduck.net Git - code/myrepos.git/blob - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

changelog improvement
[code/myrepos.git] / mr
1 #!/usr/bin/perl
2
3 #man{{{
4
5 =head1 NAME
6
7 mr - a Multiple Repository management tool
8
9 =head1 SYNOPSIS
10
11 B<mr> [options] checkout
12
13 B<mr> [options] update
14
15 B<mr> [options] status
16
17 B<mr> [options] commit [-m "message"]
18
19 B<mr> [options] diff
20
21 B<mr> [options] log
22
23 B<mr> [options] register [repository]
24
25 B<mr> [options] config section ["parameter=[value]" ...]
26
27 B<mr> [options] action [params ...]
28
29 =head1 DESCRIPTION
30
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
35 easily be added.
36
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
41
42 These predefined commands should be fairly familiar to users of any revision
43 control system:
44
45 =over 4
46
47 =item checkout (or co)
48
49 Checks out any repositories that are not already checked out.
50
51 =item update
52
53 Updates each repository from its configured remote repository.
54
55 If a repository isn't checked out yet, it will first check it out.
56
57 =item status
58
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
61
62 =item commit (or ci)
63
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
66
67 The optional -m parameter allows specifying a commit message.
68
69 =item diff
70
71 Show a diff of uncommitted changes.
72
73 =item log
74
75 Show the commit log.
76
77 =back
78
79 These commands are also available:
80
81 =over 4
82
83 =item list (or ls)
84
85 List the repositories that mr will act on.
86
87 =item register
88
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
92
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
95
96 =item config
97
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
102
103 For example, to add (or edit) a repository in src/foo:
104
105   mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
106
107 To show the command that mr uses to update the repository in src/foo:
108
109   mr config src/foo update
110
111 To see the built-in library of shell functions contained in mr:
112
113   mr config DEFAULT lib
114
115 The ~/.mrconfig file is used by default. To use a different config file,
116 use the -c option.
117
118 =item help
119
120 Displays this help.
121
122 =back
123
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
126 update"
127
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
131 system.
132
133 =head1 OPTIONS
134
135 =over 4
136
137 =item -d directory
138
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
141
142 =item -c mrconfig
143
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
145
146 =item -v
147
148 Be verbose.
149
150 =item -s
151
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
154
155 =item -n
156
157 Just operate on the repository for the current directory, do not 
158 recurse into deeper repositories.
159
160 =item -j number
161
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
164 operations.
165
166 =back
167
168 =head1 FILES
169
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
172 from repositories.
173
174 Here is an example .mrconfig file:
175
176   [src]
177   checkout = svn co svn://svn.example.com/src/trunk src
178   chain = true
179
180   [src/linux-2.6]
181   checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
182         cd linux-2.6 &&
183         git checkout -b mybranch origin/master
184
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
188
189 The "DEFAULT" section allows setting default values for the sections that
190 come after it.
191
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
194
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
198 paths.
199
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
204
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
210
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. (For the "register" action, "MR_REPO" is instead set to the 
213 basename of the directory that should be created when checking the
214 repository out.)
215
216 The "MR_CONFIG" environment variable is set to the .mrconfig file
217 that defines the repo being acted on, or, if the repo is not yet in a config
218 file, the .mrconfig file that should be modified to register the repo.
219
220 A few parameters have special meanings:
221
222 =over 4
223
224 =item skip
225
226 If the "skip" parameter is set and its command returns true, then B<mr>
227 will skip acting on that repository. The command is passed the action
228 name in $1.
229
230 Here are two examples. The first skips the repo unless
231 mr is run by joey. The second uses the hours_since function
232 (included in mr's built-in library) to skip updating the repo unless it's
233 been at least 12 hours since the last update.
234
235   skip = test $(whoami) != joey
236   skip = [ "$1" = update ] && ! hours_since "$1" 12
237
238 =item order
239
240 The "order" parameter can be used to override the default ordering of
241 repositories. The default order value is 10. Use smaller values to make
242 repositories be processed earlier, and larger values to make repositories
243 be processed later.
244
245 Note that if a repository is located in a subdirectory of another
246 repository, ordering it to be processed earlier is not recommended.
247
248 =item chain
249
250 If the "chain" parameter is set and its command returns true, then B<mr>
251 will try to load a .mrconfig file from the root of the repository. (You
252 should avoid chaining from repositories with untrusted committers.)
253
254 =item include
255
256 If the "include" parameter is set, its command is ran, and should output
257 additional mrconfig file content. The content is included as if it were
258 part of the including file.
259
260 Unlike all other parameters, this parameter does not need to be placed
261 within a section.
262
263 =item lib
264
265 The "lib" parameter can specify some shell code that will be run before each
266 command, this can be a useful way to define shell functions for other commands
267 to use.
268
269 =back
270
271 When looking for a command to run for a given action, mr first looks for
272 a parameter with the same name as the action. If that is not found, it
273 looks for a parameter named "rcs_action" (substituting in the name of the
274 revision control system and the action). The name of the revision control
275 system is itself determined by running each defined "rcs_test" action,
276 until one succeeds.
277
278 Internally, mr has settings for "git_update", "svn_update", etc. To change
279 the action that is performed for a given revision control system, you can
280 override these rcs specific actions. To add a new revision control system,
281 you can just add rcs specific actions for it.
282
283 =head1 AUTHOR
284
285 Copyright 2007 Joey Hess <joey@kitenet.net>
286
287 Licensed under the GNU GPL version 2 or higher.
288
289 http://kitenet.net/~joey/code/mr/
290
291 =cut
292
293 #}}}
294
295 use warnings;
296 use strict;
297 use Getopt::Long;
298 use Cwd qw(getcwd abs_path);
299 use POSIX "WNOHANG";
300 use constant {
301         OK => 0,
302         FAILED => 1,
303         SKIPPED => 2,
304         ABORT => 3,
305 };
306
307 $SIG{INT}=sub {
308         print STDERR "mr: interrupted\n";
309         exit 2;
310 };
311
312 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
313 my $config_overridden=0;
314 my $verbose=0;
315 my $stats=0;
316 my $no_recurse=0;
317 my $jobs=1;
318 my %config;
319 my %configfiles;
320 my %knownactions;
321 my %alias;
322 my $directory=getcwd();
323
324 Getopt::Long::Configure("no_permute");
325 my $result=GetOptions(
326         "d|directory=s" => sub { $directory=abs_path($_[1]) },
327         "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
328         "v|verbose" => \$verbose,
329         "s|stats" => \$stats,
330         "n|no-recurse" => \$no_recurse,
331         "j|jobs=i" => \$jobs,
332 );
333 if (! $result || @ARGV < 1) {
334         die("Usage: mr [-d directory] action [params ...]\n".
335             "(Use mr help for man page.)\n");
336
337 }
338 if (! defined $directory) {
339         die("mr: failed to determine working directory\n");
340 }
341
342 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
343 # the config file might be a symlink to elsewhere, and the directory it's
344 # in is significant.
345 if ($ENV{MR_CONFIG} !~ /^\//) {
346         $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
347 }
348 # Try to set MR_PATH to the path to the program.
349 eval {
350         use FindBin qw($Bin $Script);
351         $ENV{MR_PATH}=$Bin."/".$Script;
352 };
353
354 loadconfig(\*DATA);
355 loadconfig($ENV{MR_CONFIG});
356 #use Data::Dumper;
357 #print Dumper(\%config);
358
359 # alias expansion and command stemming
360 my $action=shift @ARGV;
361 if (exists $alias{$action}) {
362         $action=$alias{$action};
363 }
364 if (! exists $knownactions{$action}) {
365         my @matches = grep { /^\Q$action\E/ }
366                 keys %knownactions, keys %alias;
367         if (@matches == 1) {
368                 $action=$matches[0];
369         }
370         elsif (@matches == 0) {
371                 die "mr: unknown action \"$action\" (known actions: ".
372                         join(", ", sort keys %knownactions).")\n";
373         }
374         else {
375                 die "mr: ambiguous action \"$action\" (matches: ".
376                         join(", ", @matches).")\n";
377         }
378 }
379
380 # commands that do not operate on all repos
381 if ($action eq 'help') {
382         exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
383 }
384 elsif ($action eq 'config') {
385         if (@ARGV < 2) {
386                 die "mr config: not enough parameters\n";
387         }
388         my $section=shift;
389         if ($section=~/^\//) {
390                 # try to convert to a path relative to the config file
391                 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
392                 $dir=abs_path($dir);
393                 $dir.="/" unless $dir=~/\/$/;
394                 if ($section=~/^\Q$dir\E(.*)/) {
395                         $section=$1;
396                 }
397         }
398         my %changefields;
399         foreach (@ARGV) {
400                 if (/^([^=]+)=(.*)$/) {
401                         $changefields{$1}=$2;
402                 }
403                 else {
404                         my $found=0;
405                         foreach my $topdir (sort keys %config) {
406                                 if (exists $config{$topdir}{$section} &&
407                                     exists $config{$topdir}{$section}{$_}) {
408                                         print $config{$topdir}{$section}{$_}."\n";
409                                         $found=1;
410                                         last if $section eq 'DEFAULT';
411                                 }
412                         }
413                         if (! $found) {
414                                 die "mr $action: $section $_ not set\n";
415                         }
416                 }
417         }
418         modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
419         exit 0;
420 }
421 elsif ($action eq 'register') {
422         if (! $config_overridden) {
423                 # Find the closest known mrconfig file to the current
424                 # directory.
425                 $directory.="/" unless $directory=~/\/$/;
426                 foreach my $topdir (reverse sort keys %config) {
427                         next unless length $topdir;
428                         if ($directory=~/^\Q$topdir\E/) {
429                                 $ENV{MR_CONFIG}=$configfiles{$topdir};
430                                 last;
431                         }
432                 }
433         }
434         if (@ARGV) {
435                 my $subdir=shift @ARGV;
436                 if (! chdir($subdir)) {
437                         print STDERR "mr $action: failed to chdir to $subdir: $!\n";
438                 }
439         }
440
441         $ENV{MR_REPO}=getcwd();
442         my $command=findcommand("register", '', '', 'DEFAULT');
443         if (! defined $command) {
444                 die "mr $action: unknown repository type\n";
445         }
446
447         $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
448         $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
449                 "my_action(){ $command\n }; my_action ".
450                 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
451         print "mr $action: running >>$command<<\n" if $verbose;
452         exec($command) || die "exec: $!";
453 }
454
455 # an ordered list of repos
456 my @list;
457 foreach my $topdir (sort keys %config) {
458         foreach my $subdir (sort keys %{$config{$topdir}}) {
459                 push @list, {
460                         topdir => $topdir,
461                         subdir => $subdir,
462                         order => $config{$topdir}{$subdir}{order},
463                 };
464         }
465 }
466 @list = sort {
467                 $a->{order}  <=> $b->{order}
468                              ||
469                 $a->{topdir} cmp $b->{topdir}
470                              ||
471                 $a->{subdir} cmp $b->{subdir}
472         } @list;
473
474 # work out what repos to act on
475 my @repos;
476 my $nochdir=0;
477 foreach my $repo (@list) {
478         my $topdir=$repo->{topdir};
479         my $subdir=$repo->{subdir};
480
481         next if $subdir eq 'DEFAULT';
482         my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
483         my $d=$directory;
484         $dir.="/" unless $dir=~/\/$/;
485         $d.="/" unless $d=~/\/$/;
486         next if $no_recurse && $d ne $dir;
487         next if $dir ne $d && $dir !~ /^\Q$d\E/;
488         push @repos, [$dir, $topdir, $subdir];
489 }
490 if (! @repos) {
491         # fallback to find a leaf repo
492         foreach my $repo (reverse @list) {
493                 my $topdir=$repo->{topdir};
494                 my $subdir=$repo->{subdir};
495                 
496                 next if $subdir eq 'DEFAULT';
497                 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
498                 my $d=$directory;
499                 $dir.="/" unless $dir=~/\/$/;
500                 $d.="/" unless $d=~/\/$/;
501                 if ($d=~/^\Q$dir\E/) {
502                         push @repos, [$dir, $topdir, $subdir];
503                         last;
504                 }
505         }
506         $nochdir=1;
507 }
508
509 # run the action on each repository and print stats
510 my (@ok, @failed, @skipped);
511 if ($jobs > 1) {
512         mrs(@repos);
513 }
514 else {
515         foreach my $repo (@repos) {
516                 record($repo, action($action, @$repo));
517         }
518 }
519 if (! @ok && ! @failed && ! @skipped) {
520         die "mr $action: no repositories found to work on\n";
521 }
522 print "mr $action: finished (".join("; ",
523         showstat($#ok+1, "ok", "ok"),
524         showstat($#failed+1, "failed", "failed"),
525         showstat($#skipped+1, "skipped", "skipped"),
526 ).")\n";
527 if ($stats) {
528         if (@skipped) {
529                 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
530         }
531         if (@failed) {
532                 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
533         }
534 }
535 if (@failed) {
536         exit 1;
537 }
538 elsif (! @ok && @skipped) {
539         exit 1;
540 }
541 exit 0;
542
543 sub rcs_test { #{{{
544         my ($action, $dir, $topdir, $subdir) = @_;
545
546         my $test="set -e\n";
547         foreach my $rcs_test (
548                         sort {
549                                 length $a <=> length $b 
550                                           ||
551                                        $a cmp $b
552                         } grep { /_test/ } keys %{$config{$topdir}{$subdir}}) {
553                 my ($rcs)=$rcs_test=~/(.*)_test/;
554                 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
555                 $test.="if my_$rcs_test; then echo $rcs; fi\n";
556         }
557         $test=$config{$topdir}{$subdir}{lib}."\n".$test
558                 if exists $config{$topdir}{$subdir}{lib};
559         
560         print "mr $action: running rcs test >>$test<<\n" if $verbose;
561         my $rcs=`$test`;
562         chomp $rcs;
563         if (! length $rcs) {
564                 return undef;
565         }
566         else {
567                 return $rcs;
568         }
569 } #}}}
570         
571 sub findcommand { #{{{
572         my ($action, $dir, $topdir, $subdir) = @_;
573
574         my $rcs=rcs_test(@_);
575
576         if (defined $rcs && 
577             exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
578                 return $config{$topdir}{$subdir}{$rcs."_".$action};
579         }
580         elsif (exists $config{$topdir}{$subdir}{$action}) {
581                 return $config{$topdir}{$subdir}{$action};
582         }
583         else {
584                 return undef;
585         }
586 } #}}}
587
588 sub action { #{{{
589         my ($action, $dir, $topdir, $subdir) = @_;
590
591         $ENV{MR_CONFIG}=$configfiles{$topdir};
592         my $lib=exists $config{$topdir}{$subdir}{lib} ?
593                        $config{$topdir}{$subdir}{lib}."\n" : "";
594
595         if ($action eq 'checkout') {
596                 if (-d $dir) {
597                         print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
598                         return SKIPPED;
599                 }
600
601                 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
602
603                 if (! -d $dir) {
604                         print "mr $action: creating parent directory $dir\n" if $verbose;
605                         system("mkdir", "-p", $dir);
606                 }
607         }
608         elsif ($action =~ /update/) {
609                 if (! -d $dir) {
610                         return action("checkout", $dir, $topdir, $subdir);
611                 }
612         }
613
614         $ENV{MR_REPO}=$dir;
615
616         my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
617         my $command=findcommand($action, $dir, $topdir, $subdir);
618
619         if (defined $skiptest) {
620                 my $test="set -e;".$lib.
621                         "my_action(){ $skiptest\n }; my_action '$action'";
622                 print "mr $action: running skip test >>$test<<\n" if $verbose;
623                 my $ret=system($test);
624                 if ($ret != 0) {
625                         if (($? & 127) == 2) {
626                                 print STDERR "mr $action: interrupted\n";
627                                 return ABORT;
628                         }
629                         elsif ($? & 127) {
630                                 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
631                                 return ABORT;
632                         }
633                 }
634                 if ($ret >> 8 == 0) {
635                         print "mr $action: $dir skipped per config file\n" if $verbose;
636                         return SKIPPED;
637                 }
638         }
639         
640         if (! $nochdir && ! chdir($dir)) {
641                 print STDERR "mr $action: failed to chdir to $dir: $!\n";
642                 return FAILED;
643         }
644         elsif (! defined $command) {
645                 my $rcs=rcs_test(@_);
646                 if (! defined $rcs) {
647                         print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
648                         return FAILED;
649                 }
650                 else {
651                         print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
652                         return SKIPPED;
653                 }
654         }
655         else {
656                 if (! $nochdir) {
657                         print "mr $action: $topdir$subdir\n";
658                 }
659                 else {
660                         my $s=$directory;
661                         $s=~s/^\Q$topdir$subdir\E\/?//;
662                         print "mr $action: $topdir$subdir (in subdir $s)\n";
663                 }
664                 $command="set -e; ".$lib.
665                         "my_action(){ $command\n }; my_action ".
666                         join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
667                 print "mr $action: running >>$command<<\n" if $verbose;
668                 my $ret=system($command);
669                 if ($ret != 0) {
670                         if (($? & 127) == 2) {
671                                 print STDERR "mr $action: interrupted\n";
672                                 return ABORT;
673                         }
674                         elsif ($? & 127) {
675                                 print STDERR "mr $action: received signal ".($? & 127)."\n";
676                                 return ABORT;
677                         }
678                         print STDERR "mr $action: failed ($ret)\n" if $verbose;
679                         if ($ret >> 8 != 0) {
680                                 print STDERR "mr $action: command failed\n";
681                         }
682                         elsif ($ret != 0) {
683                                 print STDERR "mr $action: command died ($ret)\n";
684                         }
685                         return FAILED;
686                 }
687                 else {
688                         if ($action eq 'checkout' && ! -d $dir) {
689                                 print STDERR "mr $action: $dir missing after checkout\n";;
690                                 return FAILED;
691                         }
692
693                         return OK;
694                 }
695         }
696 } #}}}
697
698 # run actions on multiple repos, in parallel
699 sub mrs { #{{{
700         $| = 1;
701         my @active;
702         my @fhs;
703         my @out;
704         my $running=0;
705         while (@fhs or @repos) {
706                 while ($running < $jobs && @repos) {
707                         $running++;
708                         my $repo = shift @repos;
709                         pipe(my $outfh, CHILD_STDOUT);
710                         pipe(my $errfh, CHILD_STDERR);
711                         my $pid;
712                         unless ($pid = fork) {
713                                 die "mr $action: cannot fork: $!" unless defined $pid;
714                                 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
715                                 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
716                                 close CHILD_STDOUT;
717                                 close CHILD_STDERR;
718                                 close $outfh;
719                                 close $errfh;
720                                 exit action($action, @$repo);
721                         }
722                         close CHILD_STDOUT;
723                         close CHILD_STDERR;
724                         push @active, [$pid, $repo];
725                         push @fhs, [$outfh, $errfh];
726                         push @out, ['',     ''];
727                 }
728                 my ($rin, $rout) = ('','');
729                 my $nfound;
730                 foreach my $fh (@fhs) {
731                         next unless defined $fh;
732                         vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
733                         vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
734                 }
735                 $nfound = select($rout=$rin, undef, undef, 1);
736                 foreach my $channel (0, 1) {
737                         foreach my $i (0..$#fhs) {
738                                 next unless defined $fhs[$i];
739                                 my $fh = $fhs[$i][$channel];
740                                 next unless defined $fh;
741                                 if (vec($rout, fileno($fh), 1) == 1) {
742                                         my $r = '';
743                                         if (sysread($fh, $r, 1024) == 0) {
744                                                 close($fh);
745                                                 $fhs[$i][$channel] = undef;
746                                                 if (! defined $fhs[$i][0] &&
747                                                     ! defined $fhs[$i][1]) {
748                                                         waitpid($active[$i][0], 0);
749                                                         print STDOUT $out[$i][0];
750                                                         print STDERR $out[$i][1];
751                                                         record($active[$i][1], $? >> 8);
752                                                         splice(@fhs, $i, 1);
753                                                         splice(@active, $i, 1);
754                                                         splice(@out, $i, 1);
755                                                         $running--;
756                                                 }
757                                         }
758                                         $out[$i][$channel] .= $r;
759                                 }
760                         }
761                 }
762         }
763 } #}}}
764
765 sub record { #{{{
766         my $dir=shift()->[0];
767         my $ret=shift;
768
769         if ($ret == OK) {
770                 push @ok, $dir;
771                 print "\n";
772         }
773         elsif ($ret == FAILED) {
774                 push @failed, $dir;
775                 print "\n";
776         }
777         elsif ($ret == SKIPPED) {
778                 push @skipped, $dir;
779         }
780         elsif ($ret == ABORT) {
781                 exit 1;
782         }
783         else {
784                 die "unknown exit status $ret";
785         }
786 } #}}}
787
788 sub showstat { #{{{
789         my $count=shift;
790         my $singular=shift;
791         my $plural=shift;
792         if ($count) {
793                 return "$count ".($count > 1 ? $plural : $singular);
794         }
795         return;
796 } #}}}
797
798 my %loaded;
799 sub loadconfig { #{{{
800         my $f=shift;
801
802         my @toload;
803
804         my $in;
805         my $dir;
806         if (ref $f eq 'GLOB') {
807                 $dir="";
808                 $in=$f; 
809         }
810         else {
811                 if (! -e $f) {
812                         return;
813                 }
814
815                 my $absf=abs_path($f);
816                 if ($loaded{$absf}) {
817                         return;
818                 }
819                 $loaded{$absf}=1;
820
821                 ($dir)=$f=~/^(.*\/)[^\/]+$/;
822                 if (! defined $dir) {
823                         $dir=".";
824                 }
825                 $dir=abs_path($dir)."/";
826                 
827                 if (! exists $configfiles{$dir}) {
828                         $configfiles{$dir}=$f;
829                 }
830
831                 # copy in defaults from first parent
832                 my $parent=$dir;
833                 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
834                         if ($parent eq '/') {
835                                 $parent="";
836                         }
837                         if (exists $config{$parent} &&
838                             exists $config{$parent}{DEFAULT}) {
839                                 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
840                                 last;
841                         }
842                 }
843                 
844                 print "mr: loading config $f\n" if $verbose;
845                 open($in, "<", $f) || die "mr: open $f: $!\n";
846         }
847         my @lines=<$in>;
848         close $in;
849
850         my $section;
851         my $line=0;
852         while (@lines) {
853                 $_=shift @lines;
854                 $line++;
855                 chomp;
856                 next if /^\s*\#/ || /^\s*$/;
857                 if (/^\[([^\]]*)\]\s*$/) {
858                         $section=$1;
859                 }
860                 elsif (/^(\w+)\s*=\s*(.*)/) {
861                         my $parameter=$1;
862                         my $value=$2;
863
864                         # continued value
865                         while (@lines && $lines[0]=~/^\s(.+)/) {
866                                 shift(@lines);
867                                 $line++;
868                                 $value.="\n$1";
869                                 chomp $value;
870                         }
871
872                         if ($parameter eq "include") {
873                                 print "mr: including output of \"$value\"\n" if $verbose;
874                                 unshift @lines, `$value`;
875                                 next;
876                         }
877
878                         if (! defined $section) {
879                                 die "$f line $.: parameter ($parameter) not in section\n";
880                         }
881                         if ($section ne 'ALIAS' &&
882                             ! exists $config{$dir}{$section} &&
883                             exists $config{$dir}{DEFAULT}) {
884                                 # copy in defaults
885                                 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
886                         }
887                         if ($section eq 'ALIAS') {
888                                 $alias{$parameter}=$value;
889                         }
890                         elsif ($parameter eq 'lib') {
891                                 $config{$dir}{$section}{lib}.=$value."\n";
892                         }
893                         else {
894                                 $config{$dir}{$section}{$parameter}=$value;
895                                 if ($parameter =~ /.*_(.*)/) {
896                                         $knownactions{$1}=1;
897                                 }
898                                 else {
899                                         $knownactions{$parameter}=1;
900                                 }
901                                 if ($parameter eq 'chain' &&
902                                     length $dir && $section ne "DEFAULT" &&
903                                     -e $dir.$section."/.mrconfig") {
904                                         my $ret=system($value);
905                                         if ($ret != 0) {
906                                                 if (($? & 127) == 2) {
907                                                         print STDERR "mr $action: chain test interrupted\n";
908                                                         exit 2;
909                                                 }
910                                                 elsif ($? & 127) {
911                                                         print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
912                                                 }
913                                         }
914                                         else {
915                                                 push @toload, $dir.$section."/.mrconfig";
916                                         }
917                                 }
918                         }
919                 }
920                 else {
921                         die "$f line $line: parse error\n";
922                 }
923         }
924
925         foreach (@toload) {
926                 loadconfig($_);
927         }
928 } #}}}
929
930 sub modifyconfig { #{{{
931         my $f=shift;
932         # the section to modify or add
933         my $targetsection=shift;
934         # fields to change in the section
935         # To remove a field, set its value to "".
936         my %changefields=@_;
937
938         my @lines;
939         my @out;
940
941         if (-e $f) {
942                 open(my $in, "<", $f) || die "mr: open $f: $!\n";
943                 @lines=<$in>;
944                 close $in;
945         }
946
947         my $formatfield=sub {
948                 my $field=shift;
949                 my @value=split(/\n/, shift);
950
951                 return "$field = ".shift(@value)."\n".
952                         join("", map { "\t$_\n" } @value);
953         };
954         my $addfields=sub {
955                 my @blanks;
956                 while ($out[$#out] =~ /^\s*$/) {
957                         unshift @blanks, pop @out;
958                 }
959                 foreach my $field (sort keys %changefields) {
960                         if (length $changefields{$field}) {
961                                 push @out, "$field = $changefields{$field}\n";
962                                 delete $changefields{$field};
963                         }
964                 }
965                 push @out, @blanks;
966         };
967
968         my $section;
969         while (@lines) {
970                 $_=shift(@lines);
971
972                 if (/^\s*\#/ || /^\s*$/) {
973                         push @out, $_;
974                 }
975                 elsif (/^\[([^\]]*)\]\s*$/) {
976                         if (defined $section && 
977                             $section eq $targetsection) {
978                                 $addfields->();
979                         }
980
981                         $section=$1;
982
983                         push @out, $_;
984                 }
985                 elsif (/^(\w+)\s*=\s(.*)/) {
986                         my $parameter=$1;
987                         my $value=$2;
988
989                         # continued value
990                         while (@lines && $lines[0]=~/^\s(.+)/) {
991                                 shift(@lines);
992                                 $value.="\n$1";
993                                 chomp $value;
994                         }
995
996                         if ($section eq $targetsection) {
997                                 if (exists $changefields{$parameter}) {
998                                         if (length $changefields{$parameter}) {
999                                                 $value=$changefields{$parameter};
1000                                         }
1001                                         delete $changefields{$parameter};
1002                                 }
1003                         }
1004
1005                         push @out, $formatfield->($parameter, $value);
1006                 }
1007         }
1008
1009         if (defined $section && 
1010             $section eq $targetsection) {
1011                 $addfields->();
1012         }
1013         elsif (%changefields) {
1014                 push @out, "\n[$targetsection]\n";
1015                 foreach my $field (sort keys %changefields) {
1016                         if (length $changefields{$field}) {
1017                                 push @out, $formatfield->($field, $changefields{$field});
1018                         }
1019                 }
1020         }
1021
1022         open(my $out, ">", $f) || die "mr: write $f: $!\n";
1023         print $out @out;
1024         close $out;     
1025 } #}}}
1026
1027 # Finally, some useful actions that mr knows about by default.
1028 # These can be overridden in ~/.mrconfig.
1029 #DATA{{{
1030 __DATA__
1031 [ALIAS]
1032 co = checkout
1033 ci = commit
1034 ls = list
1035
1036 [DEFAULT]
1037 order = 10
1038 lib =
1039         error() {
1040                 echo "mr: $@" >&2
1041                 exit 1
1042         }
1043         warning() {
1044                 echo "mr (warning): $@" >&2
1045         }
1046         info() {
1047                 echo "mr: $@" >&2
1048         }
1049         hours_since() {
1050                 if [ -z "$1" ] || [ -z "$2" ]; then
1051                         error "mr: usage: hours_since action num"
1052                 fi
1053                 for dir in .git .svn .bzr CVS .hg _darcs; do
1054                         if [ -e "$MR_REPO/$dir" ]; then
1055                                 flagfile="$MR_REPO/$dir/.mr_last$1"
1056                                 break
1057                         fi
1058                 done
1059                 if [ -z "$flagfile" ]; then
1060                         error "cannot determine flag filename"
1061                 fi
1062                 delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
1063                 if [ "$delta" -lt "$2" ]; then
1064                         exit 0
1065                 else
1066                         touch "$flagfile"
1067                         exit 1
1068                 fi
1069         }
1070
1071 svn_test = test -d "$MR_REPO"/.svn
1072 git_test = test -d "$MR_REPO"/.git
1073 bzr_test = test -d "$MR_REPO"/.bzr
1074 cvs_test = test -d "$MR_REPO"/CVS
1075 hg_test  = test -d "$MR_REPO"/.hg
1076 darcs_test = test -d "$MR_REPO"/_darcs
1077 git_bare_test =
1078         test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1079         test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1080         test "$(GIT_CONFIG="$MR_REPO"/config git-config --get core.bare)" = true
1081
1082 svn_update = svn update "$@"
1083 git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
1084 bzr_update = bzr merge "$@"
1085 cvs_update = cvs update "$@"
1086 hg_update  = hg pull "$@" && hg update "$@"
1087 darcs_update = darcs pull -a "$@"
1088
1089 svn_status = svn status "$@"
1090 git_status = git status "$@" || true
1091 bzr_status = bzr status "$@"
1092 cvs_status = cvs status "$@"
1093 hg_status  = hg status "$@"
1094 darcs_status = darcs whatsnew -ls "$@"
1095
1096 svn_commit = svn commit "$@"
1097 git_commit = git commit -a "$@" && git push --all
1098 bzr_commit = bzr commit "$@" && bzr push
1099 cvs_commit = cvs commit "$@"
1100 hg_commit  = hg commit -m "$@" && hg push
1101 darcs_commit = darcs commit -a -m "$@" && darcs push -a
1102
1103 svn_diff = svn diff "$@"
1104 git_diff = git diff "$@"
1105 bzr_diff = bzr diff "$@"
1106 cvs_diff = cvs diff "$@"
1107 hg_diff  = hg diff "$@"
1108 darcs_diff = darcs diff "$@"
1109
1110 svn_log = svn log "$@"
1111 git_log = git log "$@"
1112 bzr_log = bzr log "$@"
1113 cvs_log = cvs log "$@"
1114 hg_log  = hg log "$@"
1115 darcs_log = darcs changes "$@"
1116 git_bare_log = git log "$@"
1117
1118 svn_register =
1119         url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
1120         if [ -z "$url" ]; then
1121                 error "cannot determine svn url"
1122         fi
1123         echo "Registering svn url: $url in $MR_CONFIG"
1124         mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co $url $MR_REPO"
1125 git_register = 
1126         url="$(LANG=C git-config --get remote.origin.url)" || true
1127         if [ -z "$url" ]; then
1128                 error "cannot determine git url"
1129         fi
1130         echo "Registering git url: $url in $MR_CONFIG"
1131         mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone $url $MR_REPO"
1132 bzr_register =
1133         url=$(cat .bzr/branch/parent)
1134         if [ -z "$url" ]; then
1135                 error "cannot determine bzr url"
1136         fi
1137         echo "Registering bzr url: $url in $MR_CONFIG"
1138         mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone $url $MR_REPO"
1139 cvs_register =
1140         repo=$(cat CVS/Repository)
1141         root=$(cat CVS/Root)
1142         if [ -z "$root" ]; then
1143                 error "cannot determine cvs root"
1144                 fi
1145         echo "Registering cvs repository $repo at root $root"
1146         mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d $MR_REPO $repo"
1147 hg_register = 
1148         url=$(hg showconfig paths.default)
1149         echo "Registering mercurial repo url: $url in $MR_CONFIG"
1150         mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone $url $MR_REPO"
1151 darcs_register = 
1152         url=$(cat _darcs/prefs/defaultrepo)
1153         echo "Registering darcs repository $url in $MR_CONFIG"
1154         mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get $url $MR_REPO"
1155 git_bare_register = 
1156         url="$(LANG=C GIT_CONFIG=config git-config --get remote.origin.url)" || true
1157         if [ -z "$url" ]; then
1158                 error "cannot determine git url"
1159         fi
1160         echo "Registering git url: $url in $MR_CONFIG"
1161         mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare $url $MR_REPO"
1162
1163 help =
1164         if [ ! -e "$MR_PATH" ]; then
1165                 error "cannot find program path"
1166         fi
1167         (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1168 list = true
1169 config = 
1170
1171 ed = echo "A horse is a horse, of course, of course.."
1172 T = echo "I pity the fool."
1173 right = echo "Not found."
1174 #}}}
1175
1176 # vim:sw=8:sts=0:ts=8:noet